#!/usr/bin/perl

#┌─────────────────────────────────
#│ ASKA BBS : admin.cgi - 2022/01/10
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ASKA BBS v8.1 2022/01/15
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
cgi_err('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 処理分岐
if ($in{data_men}) { data_men(); }
if ($in{pass_mgr}) { pass_mgr(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="body">
<div class="menu-msg">選択ボタンを押してください。</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl">
<tr>
	<th>選択</th>
	<th width="280">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="data_men" value="選択"></td>
	<td>データ管理</td>
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>パスワード管理</td>
</tr><tr>
	<td><input type="submit" name="logoff" value="選択"></td>
	<td>ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  管理モード
#-----------------------------------------------------------
sub data_men {
	# 画像許可
		if ($in{mode_chk} && $in{no}) {
		my %chk;
		foreach ( $cgi->param('no') ) {
			$chk{$_}++;
		}

		# 削除情報をマッチング
		my @data;
		open(DAT,"+< $cf{logfile}") or cgi_err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk) = split(/<>/);

			if (defined($chk{$no})) {
				if ($chk == 1) { $chk = 0; } else { $chk = 1; }
				$_ = "$no<>$dat<>$nam<>$eml<>$sub<>$com<>$url<>$hos<>$pwd<>$tim<>$ex<>$w<>$h<>$chk<>\n";
			}
			push(@data,$_);
		}

		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 削除処理
	} elsif ($in{job_dele} && $in{no}) {
		
		# 削除情報
		my %del;
		for ( split(/\0/,$in{no}) ) { $del{$_}++; }
		
		# 削除情報をマッチング
		my @data;
		open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
		eval "flock(DAT,2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk) = split(/<>/);

			if (defined($del{$no})) {
				unlink("$cf{imgdir}/$no$ex") if ($ex);
				unlink("$cf{imgdir}/$no-s$ex") if (-f "$cf{imgdir}/$no-s$ex");
				next;
			}
			push(@data,$_);
		}
		
		# 更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);
	
	# 修正画面
	} elsif ($in{job_edit} && $in{no}) {

		my @data;
		open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
		while (<IN>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $no) {
				@data = ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk);
				last;
			}
		}
		close(IN);

		# 修正フォームへ
		edit_form(@data);

	# 修正実行
	} elsif ($in{job} eq "edit") {

		# 未入力の場合
		if ($in{url} eq "http://") { $in{url} = ""; }
		$in{sub} ||= "無題";
		
		# 読み出し
		my @data;
		open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
		eval "flock(DAT,2);";
		while (<DAT>) {
			my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk) = split(/<>/);

			if ($in{no} == $no) {
				# 添付削除
				if ($in{del}) {
					unlink("$cf{imgdir}/$no$ex");
					unlink("$cf{imgdir}/$no-s$ex") if (-f "$cf{imgdir}/$no-s$ex");
					$ex = $w = $h = '';
				}
				$_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$hos<>$pwd<>$tim<>$ex<>$w<>$h<>$chk<>\n";
			}
			push(@data,$_);
		}
		
		# 更新
		seek(DAT,0,0);
		print DAT @data;
		truncate(DAT,tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を修正しました");
	}
	
	# ページ数
	my $page = 0;
	foreach ( keys %in ) {
		if (/^page:(\d+)/) {
			$page = $1;
			last;
		}
	}
	
	# 最大表示件数
	my $logs = 200;
	
	# 削除画面を表示
	header("管理モード");
	print <<EOM;
<div id="all">
<div class="back-btn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; メニュー">
</form>
</div>
<div class="sub-ttl">■ 管理モード</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="sid" value="$in{sid}">
<div class="ope-btn">
	<input type="submit" name="job_edit" value="修正">
	<input type="submit" name="job_dele" value="削除">
</div>
EOM

	if ($cf{imgcheck}) {
		print qq|<input type="submit" name="mode_chk" value="添付許可">\n|;
	}

	# 記事を展開
	my $i = 0;
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		next if ($i < $page + 1);
		last if ($i > $page + $logs);

		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,undef,undef,$ex,$w,$h,$chk) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);

		print qq|<div align="center"><div class="art"><dt><input type="checkbox" name="no" value="$no">\n|;
		print qq|[$no] <b>$sub</b> 投稿者：<b>$nam</b> 日時：<span style="color:green">$dat</span> [ <span style="color:#FF9966">$hos</span> ]\n|;
		print qq|<div class="com">| . cut_str($com,100) . qq|</div>\n|;

		if ($ex) {
			my $size = get_size("$cf{imgdir}/$no$ex");
			print qq|<dd>添付|;
			if ($cf{imgcheck}) {
				if ($chk == 1) { print "[○]"; } else { print "[×]"; }
			}
			print qq|：<a href="$cf{imgurl}/$no$ex" target="_blank">$no$ex</a> ($size)\n|;
		}
			print qq|</div>\n|;
	}
	close(IN);

	print "<dt>\n</dl>\n";

	# ページ繰越定義
	my $next = $page + $logs;
	my $back = $page - $logs;
	if ($back >= 0) {
		print qq|<input type="submit" name="page:$back" value="前ページ">\n|;
	}
	if ($next < $i) {
		print qq|<input type="submit" name="page:$next" value="次ページ">\n|;
	}

	print <<EOM;
<dt></dl></div></div>
</form></body></html>
EOM
	exit;
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pwd,$tim,$ex,$w,$h,$chk) = @_;
	
	$com =~ s|<br( /)?>|\n|g;
	$url ||= "http://";

	my $clip;
	if ($ex) {
		$clip .= qq|[<a href="$cf{imgurl}/$no$ex" target="_blank">添付</a>]\n|;
		$clip .= qq|<input type="checkbox" name="del" value="1">削除\n|;
	}
	
	header("管理モード ＞ 修正フォーム");
	print <<EOM;
<div id="all">
<div class="back-btn">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="sid" value="$in{sid}">
<input type="submit" value="&lt; 前画面">
</form>
</div>
<div class="sub-ttl">■ 編集フォーム</div>
<ul>
<li>変更する部分のみ修正して送信ボタンを押してください。
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="mode" value="admin">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="job" value="edit">
<input type="hidden" name="no" value="$no">
<input type="hidden" name="sid" value="$in{sid}">
<div id="reg-box">
<table id="reg-tbl">
<tr>
  <th><b>記事NO</b></th>
  <td><b style="font-size:14pt">$no</b></td>
</tr><tr>
  <th><b>おなまえ</b></th>
  <td><input type="text" name="name" value="$nam" class="reg-name" style="color:gray; border-width:1px; border-color:rgb(166,136,189); border-style:dotted;"></td>
</tr><tr>
  <th><b>Ｅメール</b></th>
  <td><input type="text" name="email" value="$eml" class="reg-name" style="color:gray; border-width:1px; border-color:rgb(166,136,189); border-style:dotted;"></td>
</tr><tr>
  <th><b>タイトル</b></th>
  <td><input type="text" name="sub" value="$sub" class="reg-name" style="color:gray; border-width:1px; border-color:rgb(166,136,189); border-style:dotted;"></td>
</tr><tr>
  <th><b>参照先</b></th>
  <td><input type="text" name="url" value="$url" class="reg-url" style="color:gray; border-width:1px; border-color:rgb(166,136,189); border-style:dotted;"></td>
</tr><tr>
  <th><b>添付</b></th>
  <td>$clip</td>
</tr><tr>
  <th><b>メッセージ</b></th>
  <td><textarea name="comment" class="reg-com" rows="7" style="color:gray; border-width:1px; border-color:rgb(166,136,189); border-style:dotted;">$com</textarea>
	<br><input type="submit" class="reg-btn" value="送信する">&nbsp;&nbsp;<input type="reset" class="reg-btn" value="リセット">
</td>
</tr>
</table>
</form>
</div></div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;
	
	print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<meta http-equiv="content-script-type" content="text/javascript" />
<meta http-equiv="content-style-type" content="text/css" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<link href="cmn/admin.css" rel="stylesheet" type="text/css" />
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="$cf{cmnurl}/star.png" alt="star" class="icon">
	AskaBBS 管理画面 ::
</div>
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	header("ERROR!");
	print <<EOM;
<div id="err">
<p><b>ERROR!</b></p>
<p class="err">$err</p>
<p><input type="button" value="前画面に戻る" onclick="history.back()"></p>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	header("完了");
	print <<EOM;
<div id="message">
<p class="msg">$msg</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="pass" value="$in{pass}">
<input type="submit" value="管理画面に戻る">
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	my $i = 0;
	my ($ret,$flg);
	while ($str =~ /([\x00-\x7f]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/gx) {
		$i++;
		$ret .= $1;
		if ($i >= $all) {
			$flg++;
			last;
		}
	}
	$ret .= '...' if ($flg);
	
	return $ret;
}

