#!/usr/bin/perl

#┌─────────────────────────────────
#│ ASKA-BBS : check.cgi - 2021/07/23
#│ copyright (c) kentweb, 1997-2021
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  ASKA BBS v8.22 : check.cgi - 2022/11/22
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 外部ファイル取り込み
require './init.cgi';
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
<li>Perlバージョン : $]
EOM

# ディレクトリ
my %dir = (
	$cf{imgdir}          => '画像ディレクトリ',
	$cf{cmnurl}          => '共用ディレクトリ',
	$cf{datadir}         => 'データディレクトリ',
	"$cf{datadir}/past"  => '過去ログディレクトリ',
	"$cf{datadir}/pwd"   => '管理パスワードディレクトリ',
	"$cf{datadir}/ses"   => '管理パスワードセッションディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		#next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# データファイル
my %log = (
	"$cf{datadir}/log.cgi"       => '記事ログファイル',
	"$cf{datadir}/count.dat"     => 'カウントファイル',
	"$cf{datadir}/pastno.dat"    => '過去ログデータ番号ファイル',
	"$cf{datadir}/pass.dat"      => '管理パスワードデータファイル',
	"$cf{datadir}/ses.cgi"       => 'ログインセッションファイル',
	"$cf{datadir}/conf.cgi"      => '確認画面用セッションファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# テンプレート
foreach (qw(album album_past bbs conf del edit enter error find form gate mesg note past read-conf read)) {
	if (-f "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM
exit;

